package Modules;

import net.dv8tion.jda.api.events.GenericEvent;

public interface Module {

    /**
     * name of the command
     * @return command
     */
    String getCommand();

    /**
     * Text shown in the Help message
     * @return Description
     */
    String getDescription();

    /**
     * Recives Guild Updates
     * @param genericEvent Guild Updates
     */
    void execute(GenericEvent genericEvent);

    /**
     * Returns the current settings of the module
     * When no settings are needed return NULL
     * @return current settings
     */
    String showSettings();
}
